package vo

// SubCode @link https://docs.qq.com/doc/DTU5mdGJ2b0xndXNJ
// @link https://open.unionpay.com/tjweb/api/interface?apiSvcId=3161&id=19701
type SubCode string

const (
	SubCodeUP07006 SubCode = "UP07006"
	SubCodeUP07007 SubCode = "UP07007"
	SubCodeUP07008 SubCode = "UP07008"
	SubCodeUP07009 SubCode = "UP07009"
	SubCodeUP07011 SubCode = "UP07011"
	SubCodeUP07016 SubCode = "UP07016"
	SubCodeUP07017 SubCode = "UP07017"
	SubCodeUP07018 SubCode = "UP07018"
	SubCodeUP07019 SubCode = "UP07019"
	SubCodeUP07021 SubCode = "UP07021"
	SubCodeUP07097 SubCode = "UP07097"
	SubCodeUP07098 SubCode = "UP07098"
	SubCodeUP07099 SubCode = "UP07099"
	SubCodeUP07400 SubCode = "UP07400"

	SubCodeUp02094 SubCode = "UP02094"
	SubCodeUp02099 SubCode = "UP02099"
	SubCodeUp06003 SubCode = "UP06003"
	SubCodeUp06004 SubCode = "UP06004"
	SubCodeUp06005 SubCode = "UP06005"
	SubCodeUp06006 SubCode = "UP06006"
	SubCodeUp06007 SubCode = "UP06007"
	SubCodeUp06008 SubCode = "UP06008"
	SubCodeUp06009 SubCode = "UP06009"
	SubCodeUp06010 SubCode = "UP06010"
	SubCodeUp06011 SubCode = "UP06011"
	SubCodeUp06012 SubCode = "UP06012"
	SubCodeUp06021 SubCode = "UP06021"
	SubCodeUp06022 SubCode = "UP06022"
	SubCodeUp06034 SubCode = "UP06034"
	SubCodeUp06035 SubCode = "UP06035"
	SubCodeUp06036 SubCode = "UP06036"
	SubCodeUp06037 SubCode = "UP06037"
	SubCodeUp06038 SubCode = "UP06038"
	SubCodeUp06039 SubCode = "UP06039"
	SubCodeUp06040 SubCode = "UP06040"
	SubCodeUp06041 SubCode = "UP06041"
	SubCodeUp06042 SubCode = "UP06042"
	SubCodeUp06043 SubCode = "UP06043"
	SubCodeUp06044 SubCode = "UP06044"
	SubCodeUp06045 SubCode = "UP06045"
	SubCodeUp07001 SubCode = "UP07001"
	SubCodeUp07002 SubCode = "UP07002"
	SubCodeUp07003 SubCode = "UP07003"
	SubCodeUp07004 SubCode = "UP07004"
	SubCodeUp07005 SubCode = "UP07005"
	SubCodeUp07010 SubCode = "UP07010"
	SubCodeUp07012 SubCode = "UP07012"
	SubCodeUp07013 SubCode = "UP07013"
	SubCodeUp07014 SubCode = "UP07014"
	SubCodeUp07015 SubCode = "UP07015"
	SubCodeUp07020 SubCode = "UP07020"
	SubCodeUp07030 SubCode = "UP07030"
	SubCodeUp07050 SubCode = "UP07050"
	SubCodeUp07051 SubCode = "UP07051"
	SubCodeUp07052 SubCode = "UP07052"
	SubCodeUp00030 SubCode = "UP00030"
	SubCodeUp00050 SubCode = "UP00050"
	SubCodeUp00080 SubCode = "UP00080"
	SubCodeUp02025 SubCode = "UP02025"
	SubCodeUp02071 SubCode = "UP02071"

	SubCodeUP07600 SubCode = "UP07600"
	SubCodeUP07601 SubCode = "UP07601"
	SubCodeUP07602 SubCode = "UP07602"
	SubCodeUP07603 SubCode = "UP07603"
	SubCodeUP07604 SubCode = "UP07604"
	SubCodeUP07605 SubCode = "UP07605"
	SubCodeUP07606 SubCode = "UP07606"
	SubCodeUP07607 SubCode = "UP07607"
	SubCodeUP07608 SubCode = "UP07608"
	SubCodeUP07609 SubCode = "UP07609"
	SubCodeUP07610 SubCode = "UP07610"
	SubCodeUP07611 SubCode = "UP07611"
	SubCodeUP07612 SubCode = "UP07612"
)

var codeMsg = map[SubCode]string{
	SubCodeUP07006: "积分撤销业务异常",
	SubCodeUP07007: "积分退货业务异常",
	SubCodeUP07008: "积分调账业务异常",
	SubCodeUP07009: "积分归并业务异常",
	SubCodeUP07011: "调用外部系统服务异常",
	SubCodeUP07016: "积分赠送调用封顶规则失败",
	SubCodeUP07017: "调用热点账户动账失败",
	SubCodeUP07018: "幂等校验异常",
	SubCodeUP07019: "账户校验异常",
	SubCodeUP07021: "积分消费撤销业务异常",
	SubCodeUP07097: "积分业务系统熔断",
	SubCodeUP07098: "积分业务系统限流",
	SubCodeUP07099: "系统异常",
	SubCodeUP07400: "积分查询为空",

	SubCodeUp02094: "交易重复",
	SubCodeUp02099: "交易单品信息无效",
	SubCodeUp06003: "线上折扣活动不存在",
	SubCodeUp06004: "线上折扣活动已下线",
	SubCodeUp06005: "线上折扣活动未开始",
	SubCodeUp06006: "线上折扣活动已结束",
	SubCodeUp06007: "线上折扣活动已过期(当前消费请求已不满足)",
	SubCodeUp06008: "线上折扣活动多方出资配置或者计算错误",
	SubCodeUp06009: "线上折扣活动查询结果不满足消费请求(适用于查询并承兑)",
	SubCodeUp06010: "折扣活动承兑金额检验错误",
	SubCodeUp06011: "线上折扣活动余额不足",
	SubCodeUp06012: "线上折扣活动当前周期余额不足",
	SubCodeUp06021: "线上折扣活动城市校验失败，定位城市非活动城市",
	SubCodeUp06022: "线上折扣活动城市校验失败，交易未上送定位城市",
	SubCodeUp06034: "线上折扣活动参与卡付失败封顶",
	SubCodeUp06035: "线上折扣活动参与手机封顶",
	SubCodeUp06036: "线上折扣活动参与银行卡封顶",
	SubCodeUp06037: "线上折扣活动参与迷你付终端封顶",
	SubCodeUp06038: "线上折扣活动参与用户封顶",
	SubCodeUp06039: "线上折扣活动参与账单号封顶",
	SubCodeUp06040: "线上折扣活动参与用户商品数量封顶",
	SubCodeUp06041: "线上折扣活动参与证件号封顶",
	SubCodeUp06042: "线上折扣活动参与商户号封顶",
	SubCodeUp06043: "线上折扣活动参与人脸证件号封顶",
	SubCodeUp06044: "线上折扣活动参与商户Pos终端封顶",
	SubCodeUp06045: "线上折扣活动参与活动封顶",
	SubCodeUp07001: "优惠券下载失败",
	SubCodeUp07002: "优惠券冻结失败",
	SubCodeUp07003: "优惠券删除失败",
	SubCodeUp07004: "优惠券操作结果查询失败",
	SubCodeUp07005: "优惠券开放平台权限校验失败",
	SubCodeUp07010: "用户优惠券张数超过限制",
	SubCodeUp07012: "优惠券下载封顶累计失败",
	SubCodeUp07013: "优惠券下载调用账务失败",
	SubCodeUp07014: "优惠券下载卡号反查用户ID失败",
	SubCodeUp07015: "优惠券下载手机号反查用户ID失败",
	SubCodeUp07020: "优惠券冻结调用账务失败",
	SubCodeUp07030: "优惠券删除调用账户失败",
	SubCodeUp07050: "优惠券下载维度无效",
	SubCodeUp07051: "用户送券维度：当前用户未实名认证",
	SubCodeUp07052: "用户送券维度：可用银行卡与当前账户不同名，需绑定同名卡",
	SubCodeUp00030: "请求报文错误(无效)",
	SubCodeUp00050: "线上折扣系统并发控制限制",
	SubCodeUp00080: "线上折扣系统内部错误",
	SubCodeUp02025: "原交易不存在",
	SubCodeUp02071: "交易无效",

	SubCodeUP07600: "调用规则查询积分信息异常/积分ID不存在",
	SubCodeUP07601: "调用账户系统查询异常",
	SubCodeUP07602: "调用账户系统动账异常",
	SubCodeUP07603: "调用账户系统冲账异常",
	SubCodeUP07604: "调用热点账户系统异常",
	SubCodeUP07605: "调用统一用户系统异常",
	SubCodeUP07606: "调用热点账户系统异常",
	SubCodeUP07607: "触发用户规则",
	SubCodeUP07608: "原交易不存在",
	SubCodeUP07609: "接入方余额不足",
	SubCodeUP07610: "接入方关联积分Id不匹配",
	SubCodeUP07611: "用统一用户-用户红包开关权限未开启",
	SubCodeUP07612: "用统一用户-调用商户权限异常",
}

func (code SubCode) GetMsg() string {
	msg, ok := codeMsg[code]
	if !ok {
		return "未知错误代码"
	}
	return msg
}
